#include <stdio.h>

using namespace std;

int main(){
    int n, k;
    scanf("%d %d", &n, &k);
    int a[n];
    for (int i = 0; i < n; i++){
        scanf("%d", &a[i]);
    }
    bool b[n] = {false};
    int start = 0;
    while (k > 0){
        if (start + k - 1 == n){
            for (int i = start - 1; i < n; i++){
                b[i] = true;
                k--;
            }
        }
        int minV = -1, minI;
        for (int i = start; i < start + k + 1; i++){
            if (minV == -1 || minV > a[i]){
                minV = a[i];
                minI = i;
            }
        }
        for (int i = start; i < minI; i++){
            b[i] = true;
            k--;
        }
        start = minI + 1;
    }
    for (int i = 0; i < n; i++){
        if (!b[i]) printf("%d ", a[i]);
    }
    return 0;
}